//-----------------------------------------------------------------------
// i_MF_Fractal_ZZ_3in1_Expire.mq4
//       
// ,     .
//      ,  ..   
// + 
// :
// -      ,  ,  
//    . 
// -   <=    
// - TFSmall < TFMidle && TFMidle < TFLarge
// - TFLarge <=43200 () 
//-----------------------------------------------------------------------

#property copyright "Copyright  2008, BiViSi Corp."
#property link      "riderfin@bk.ru"
#property link      "ICQ 499949112"

#property indicator_chart_window    
#property indicator_buffers 7
//----    
#property indicator_color1 Blue 
#property indicator_color2 Red
#property indicator_color3 Yellow        
#property indicator_style1 0
#property indicator_style2 0
#property indicator_style3 0
#property indicator_width1 5
#property indicator_width2 3
#property indicator_width3 1
//----    
extern int VolExt=50; //  "VolExt+1"   
extern int TFLarge=720;
extern int TFMidle=240;
extern int TFSmall=60;
//---- Variables 
double Large[],Midle[],Small[];  //   ( )
double LargeVector[], MidleVector[];                    //   ( 1  - Large)
double MidleLevel[], SmallLevel []; //   
datetime PrevTimePer[4];         //      
datetime PrevTimeCalc=0, PrevTimeCalcVector=0; 
double P60,CP60;
int CurPeriod, ErrorTF=0, NumberExt, Per,  largelast=0, midlelast=0, smalllast=0;
//-----------------------------------------------------------------------
int init() 
{

   //  
   //IndicatorBuffers(7); //  " " :)
   SetIndexBuffer(0,Large); SetIndexStyle(0,DRAW_SECTION);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,Midle); SetIndexStyle(1,DRAW_SECTION);
   SetIndexEmptyValue(1,0.0); 
   SetIndexBuffer(2,Small); SetIndexStyle(2,DRAW_SECTION);
   SetIndexEmptyValue(2,0.0);
   SetIndexBuffer(3,LargeVector); //SetIndexStyle(2,DRAW_SECTION);
   SetIndexEmptyValue(3,0.0);
   SetIndexBuffer(4,MidleVector); //SetIndexStyle(2,DRAW_SECTION);
   SetIndexEmptyValue(4,0.0);
   SetIndexBuffer(5,MidleLevel); //SetIndexStyle(2,DRAW_SECTION);
   SetIndexEmptyValue(5,0.0);
   SetIndexBuffer(6,SmallLevel); //SetIndexStyle(2,DRAW_SECTION);
   SetIndexEmptyValue(6,0.0);
   
   ArrayInitialize(PrevTimePer,0);
   CurPeriod=Period(); CP60=CurPeriod*60;
   // :
   //     
   if (MathCeil(TFSmall/CurPeriod) != TFSmall/CurPeriod) 
      TFSmall=MathCeil(TFSmall/CurPeriod)*CurPeriod;
   if (MathCeil(TFMidle/CurPeriod) != TFMidle/CurPeriod)
      TFMidle=MathCeil(TFMidle/CurPeriod)*CurPeriod;
   if (MathCeil(TFLarge/CurPeriod) != TFLarge/CurPeriod)
       TFLarge=MathCeil(TFLarge/CurPeriod)*CurPeriod;
   if (CurPeriod > TFSmall) 
      {Alert ("       ", TFSmall," .");
       ErrorTF=1;return;}
   if (TFSmall >= TFMidle || TFMidle >= TFLarge || TFLarge>43200)
      {Alert ("    !!!"); ErrorTF=1;return;}

   //   ,   
   ObjectCreate("LargeVector",OBJ_LABEL,0,0,0,0,0);ObjectSet("LargeVector",OBJPROP_CORNER,0);ObjectSet("LargeVector",OBJPROP_XDISTANCE,5);ObjectSet("LargeVector",OBJPROP_YDISTANCE,30);
   ObjectCreate("MidleVector",OBJ_LABEL,0,0,0,0,0);ObjectSet("MidleVector",OBJPROP_CORNER,0);ObjectSet("MidleVector",OBJPROP_XDISTANCE,55);ObjectSet("MidleVector",OBJPROP_YDISTANCE,35);
   ObjectCreate("SmallVector",OBJ_LABEL,0,0,0,0,0);ObjectSet("SmallVector",OBJPROP_CORNER,0);ObjectSet("SmallVector",OBJPROP_XDISTANCE,55);ObjectSet("SmallVector",OBJPROP_YDISTANCE,55);
   ObjectCreate("MidleLevel",OBJ_LABEL,0,0,0,0,0);ObjectSet("MidleLevel",OBJPROP_CORNER,0);ObjectSet("MidleLevel",OBJPROP_XDISTANCE,80);ObjectSet("MidleLevel",OBJPROP_YDISTANCE,35);
   ObjectCreate("SmallLevel",OBJ_LABEL,0,0,0,0,0);ObjectSet("SmallLevel",OBJPROP_CORNER,0);ObjectSet("SmallLevel",OBJPROP_XDISTANCE,80);ObjectSet("SmallLevel",OBJPROP_YDISTANCE,55);
   ObjectCreate("MidleTrade",OBJ_LABEL,0,0,0,0,0);ObjectSet("MidleTrade",OBJPROP_CORNER,0);ObjectSet("MidleTrade",OBJPROP_XDISTANCE,140);ObjectSet("MidleTrade",OBJPROP_YDISTANCE,35);
   ObjectCreate("SmallTrade",OBJ_LABEL,0,0,0,0,0);ObjectSet("SmallTrade",OBJPROP_CORNER,0);ObjectSet("SmallTrade",OBJPROP_XDISTANCE,140);ObjectSet("SmallTrade",OBJPROP_YDISTANCE,55);
   
   return;              
}
//--------------------------------------------------------------------
int start()
{
   if ( ErrorTF==1 ) return; //     
   FractalCalc(); 
   VectorCalc();
   return;
}
//======================================================================
//     
//    ,  Midle   Large,
//  Small   Midle
//======================================================================   

void VectorCalc()
{
   if (PrevTimeCalcVector == Time[0]) return; else PrevTimeCalcVector = Time[0];
   int x, y, j=TFLarge*10;
   //int y, x, k, i, j=Bars-1;
   //     ZZ
   for (y=1; y<=3; y++)
      {
      NumberExt=0;
      for (x=1; x<j; x++)
         {
         if (y==1 && Large[x] !=0.0)
            { 
            if (Large[x] == High[x]){LargeVector[1]=-1; ObjectSetText("LargeVector",CharToStr(248),40,"Wingdings",Blue);}// dn
            else {LargeVector[1]=1; ObjectSetText("LargeVector",CharToStr(246),40,"Wingdings",Blue);}// up
            break;   
            }
         if (y==2 && Midle[x] !=0.0)
            {
            if (NumberExt==0)
               {
               if (Midle[x] == High[x]){MidleVector[1]=-1; ObjectSetText("MidleVector",CharToStr(238),12,"Wingdings",Red);}//dn
               else {MidleVector[1]=1; ObjectSetText("MidleVector",CharToStr(236),12,"Wingdings",Red);} //up
               NumberExt++;
               }            
            if (LargeVector[1]>0 && Midle[x]==High[x])
               {
               ObjectSetText("MidleLevel",DoubleToStr(Midle[x], Digits),11,"Tahoma",Red);               
               MidleLevel[1]=Midle[x]; break;
               }
            if (LargeVector[1]<0 && Midle[x]==Low[x])
               {
               ObjectSetText("MidleLevel",DoubleToStr(Midle[x], Digits),11,"Tahoma",Red);               
               MidleLevel[1]=Midle[x]; break;
               }
            }
         if (y==3 && Small[x] !=0.0)
            {
            if (NumberExt==0)
               {
               if (Small[x] == High[x])ObjectSetText("SmallVector",CharToStr(238),12,"Wingdings",Yellow);//dn
               else ObjectSetText("SmallVector",CharToStr(236),12,"Wingdings",Yellow); //up 228 230
               NumberExt++;
               }            
            if (MidleVector[1]>0 && LargeVector[1]>0 && Small[x]==High[x])
               {
               ObjectSetText("SmallLevel",DoubleToStr(Small[x], Digits),11,"Tahoma",Yellow);
               SmallLevel[1]=Small[x]; break;
               }
            if (MidleVector[1]<0 && LargeVector[1]<0 && Small[x]==Low[x])
               {
               ObjectSetText("SmallLevel",DoubleToStr(Small[x], Digits),11,"Tahoma",Yellow);
               SmallLevel[1]=Small[x]; break;
               }
            }   
         }
      }
   //     Midle
   if (LargeVector[1]>0) ObjectSetText("MidleTrade",CharToStr(225),12,"Wingdings",Red); //up
   else if (LargeVector[1]<0) ObjectSetText("MidleTrade",CharToStr(226),12,"Wingdings",Red); //dn
   else  ObjectSetText("MidleTrade",CharToStr(139),14,"Wingdings",White); // 
   //     Small
   if (LargeVector[1]>0 && MidleVector[1]>0) ObjectSetText("SmallTrade",CharToStr(225),12,"Wingdings",Yellow); //up
   else if (LargeVector[1]<0 && MidleVector[1]<0) ObjectSetText("SmallTrade",CharToStr(226),12,"Wingdings",Yellow); //dn
   else ObjectSetText("SmallTrade",CharToStr(139),14,"Wingdings",White); // 
}

//======================================================================
//  5-       
//    ,       
//======================================================================
void FractalCalc ()
{   
   // Force  1 -        
   if (PrevTimeCalc == Time[0]) return; else PrevTimeCalc=Time[0];
   int y, x, k, i, j, extr=0; 
   //     ,   1-5  
   int t1, t2, t3, t4, t5;                     
   //     ,   1-5  
   int limit1, limit2, limit3, limit4, limit5; 
   //           1-5  
   int up1,up2,up3,up4,up5,dn1,dn2,dn3,dn4,dn5;
      
   for (y=1; y<=3; y++) //    
      {
      if (y==1) Per=TFLarge; if (y==2) Per=TFMidle; if (y==3) Per=TFSmall;
      P60=Per*60;
      // Force 2 -        
      if (PrevTimePer[y] !=0)
         { 
         // 
         if (Per<43200 && (Time[0] - PrevTimePer[y])<P60 )continue;
          //   ,  
         // if (Per<43200 && (TimeCurrent() - PrevTimePer[y])<Per*60 )continue;
         if (Per==43200 && Month()==TimeMonth(PrevTimePer[y]))continue;
         }
      //   PrevTimePer[y]=Time[0];     
      //           
      PrevTimePer[y]=MathCeil(Time[0]/Per/60)*P60; 
      
      NumberExt=0;  extr=0;
      k=Per/CurPeriod;
      //   -       
      //     
      i=MathCeil(Bars/k)-5;
      // Force #3 - ,    
      if(y==1 && largelast !=0) i=largelast+k; // +k 
      if(y==2 && midlelast !=0) i=midlelast+k; // +k 
      if(y==3 && smalllast !=0) i=smalllast+k; // +k 
      for (x=1; x<=i; x++) 
         {
         //    
         //      ,   1  
         //  -   !!!!!!!!!!!!
         //##################     ###############################
         //t1=MathCeil(TimeCurrent()/Per/60)*P60-x*P60+(k-1)*CurPeriod*60;
         //##################    ############################### 
         //t1=MathCeil(Time[0]/Per/60)*P60-x*P60+(k-1)*CurPeriod*60;
         //   ,   
         if (PrevTimePer[y] !=0) t1=PrevTimePer[y]-x*P60+(k-1)*CP60;
         else t1=MathCeil(Time[0]/Per/60)*P60-x*P60+(k-1)*CP60;
         t2=t1-P60; t3=t2-P60; t4=t3-P60; t5=t4-P60;
         limit1=iBarShift(NULL,0,t1, false); limit2=iBarShift(NULL,0,t2, false);
         limit3=iBarShift(NULL,0,t3, false); limit4=iBarShift(NULL,0,t4, false);
         limit5=iBarShift(NULL,0,t5, false);         
         up1=iHighest(NULL,0,MODE_HIGH,k,limit1);
         up2=iHighest(NULL,0,MODE_HIGH,k,limit2);
         up3=iHighest(NULL,0,MODE_HIGH,k,limit3);
         up4=iHighest(NULL,0,MODE_HIGH,k,limit4);
         up5=iHighest(NULL,0,MODE_HIGH,k,limit5);
         dn1=iLowest(NULL,0,MODE_LOW,k,limit1);
         dn2=iLowest(NULL,0,MODE_LOW,k,limit2);
         dn3=iLowest(NULL,0,MODE_LOW,k,limit3);
         dn4=iLowest(NULL,0,MODE_LOW,k,limit4);
         dn5=iLowest(NULL,0,MODE_LOW,k,limit5);

         //   
         if(High[up3]>High[up2] && High[up3]>High[up1] && High[up3]>=High[up4] && High[up3]>=High[up5])
            {
            if (y==1){Large[up3]=High[up3];largelast=up3;}
            if (y==2){Midle[up3]=High[up3];midlelast=up3;}
            if (y==3){Small[up3]=High[up3];smalllast=up3;}
            NumberExt++;  extr++;
            }
         if(Low[dn3]<Low[dn2] && Low[dn3]<Low[dn1] && Low[dn3]<=Low[dn4] && Low[dn3]<=Low[dn5])
            {
            if (y==1){Large[dn3]=Low[dn3];largelast=dn3;}
            if (y==2){Midle[dn3]=Low[dn3];midlelast=dn3;}
            if (y==3){Small[dn3]=Low[dn3];smalllast=dn3;}
            NumberExt++; extr++;
            }
         if (NumberExt>VolExt) break;   
         } 
      }

//       
//  2-     \  \,
//    -     ....  

   if (extr==0) return;
   for (y=1; y<=3; y++)
      {
      if (y==1) j=ArraySize(Large);if (y==2)j=ArraySize(Midle);
      if (y==3)j=ArraySize(Small);      
      int min=0, max=0, extmin=0, extmax=0;
      NumberExt=0;      
      for (x=1;x<=j;x++)
         {
         if (y==1)
            {
            if (Large[x] == 0.0 ) continue;
            if (Large[x] == High[x])
               {
               NumberExt++; extmax++; extmin=0;
               if (extmax==2)
                  {
                  if (Large[max]>=Large[x])Large[x]=0.0;
                  else {Large[max]=0.0;max=x;}
                  extmax--;  
                  }
               else max=x;
               }
            if (Large[x] == Low[x])
               {
               NumberExt++; extmax=0; extmin++;
               if (extmin==2)
                  {
                  if (Large[min]<=Large[x])Large[x]=0.0;
                  else {Large[min]=0.0;min=x;}
                  extmin--;  
                  }
               else min=x;
               }
            }         
         if (y==2)
            {
            if (Midle[x] == 0.0 ) continue;
            if (Midle[x] == High[x])
               {
               NumberExt++; extmax++; extmin=0;
               if (extmax==2)
                  {
                  if (Midle[max]>=Midle[x])Midle[x]=0.0;
                  else {Midle[max]=0.0;max=x;}
                  extmax--;  
                  //   ,  , ....  
                  /*
                  if (Midle[max]>Midle[x])Midle[x]=0.0; 
                  if (Midle[max]==Midle[x])
                     {
                     if (Large[x] == High[x]) {Midle[max]=0.0;max=x;}
                     else Midle[x]=0.0; 
                     }
                  if (Midle[max]<Midle[x]){Midle[max]=0.0;max=x;}
                  */
                  }
               else max=x;
               }
            if (Midle[x] == Low[x])
               {
               NumberExt++; extmax=0; extmin++;
               if (extmin==2)
                  {
                  if (Midle[min]<=Midle[x])Midle[x]=0.0;
                  else {Midle[min]=0.0;min=x;}
                  extmin--;  
                  //   ,  , ....  
                  /*
                  if (Midle[min]<Midle[x])Midle[x]=0.0; 
                  if (Midle[min]==Midle[x])
                     {
                     if (Large[x] == Low[x]) {Midle[min]=0.0;min=x;}
                     else Midle[x]=0.0; 
                     }
                  if (Midle[min]>Midle[x]){Midle[min]=0.0;min=x;}
                  */
                  }
               else min=x;
               }
            }         
         if (y==3)
            {
            if (Small[x] == 0.0 ) continue;
            if (Small[x] == High[x])
               {
               NumberExt++; extmax++; extmin=0;
               if (extmax==2)
                  {
                  if (Small[max]>=Small[x])Small[x]=0.0;
                  else {Small[max]=0.0;max=x;}
                  extmax--;  
                  //   ,  , ....  
                  /*
                  if (Small[max]>Small[x])Small[x]=0.0; 
                  if (Small[max]==Small[x])
                     {
                     if (Midle[x] == High[x]) {Small[max]=0.0;max=x;}
                     else Small[x]=0.0; 
                     }
                  if (Small[max]<Small[x]){Small[max]=0.0;max=x;}
                  */
                  }
               else max=x;
               }
            if (Small[x] == Low[x])
               {
               NumberExt++; extmax=0; extmin++;
               if (extmin==2)
                  {
                  if (Small[min]<=Small[x])Small[x]=0.0;
                  else {Small[min]=0.0;min=x;}
                  extmin--;  
                  //   ,  , ....  
                  /*
                  if (Small[min]<Small[x])Small[x]=0.0; 
                  if (Small[min]==Small[x])
                     {
                     if (Midle[x] == Low[x]) {Small[min]=0.0;min=x;}
                     else Small[x]=0.0; 
                     }
                  if (Small[min]>Small[x]){Small[min]=0.0;max=x;}
                  */
                  }
               else min=x;
               }
            }         
         if (NumberExt>VolExt+5) break;
         }
      }         

}
//--------------------------------------------------------------------

